<?php

/**
 * inf_etapa_procesal actions.
 *
 * @package    cobro_coactivo
 * @subpackage inf_etapa_procesal
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_etapa_procesalActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.no_proceso,tab0.id_anhos,tab0.fecha  ';
        }



        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables para el registro de log
             */

            //1 - indica operacion de consulta
            $id_ope_bd = 1;

            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('CBR_REGISTRO_ETAPA');


            //CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, $observacion);

            /*
             * Filtro para que levante por TITULO MINERO y por FASE
             */


            $whereTituloMinero = "";
            $whereNumeroProceso = "";
            $whereEtapaProc = "";


            if (isset($request['cod_titulo'])) {
                $whereTituloMinero.=" AND tab0.cod_titulo='" . $request['cod_titulo'] . "'";
            }

            if (isset($request['no_proceso'])) {
                $whereNumeroProceso.=" AND tab0.no_proceso=" . $request['no_proceso'];
            }

            if (isset($request['id_actuacion_proc'])) {
                $whereEtapaProc.=" AND tab0.id_actuacion_proc=" . $request['id_actuacion_proc'];
            }

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */

            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Tercero
            if (isset($request['num_doc'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //no_radicado
            if (isset($request['no_radicado'])) {
                $whereNoRadicado = " AND tab0.no_radicado = '" . $request['no_radicado'] . "'";
            } else {
                $whereNoRadicado = ' ';
            }
            //no_obligacion
            if (isset($request['no_obligacion'])) {
                $whereNoObligacion = " AND tab0.no_obligacion = '" . $request['no_obligacion'] . "'";
            } else {
                $whereNoObligacion = ' ';
            }
            //no_rp
            if (isset($request['no_rp'])) {
                $whereNoRp = " AND tab0.no_rp = '" . $request['no_rp'] . "'";
            } else {
                $whereNoRp = ' ';
            }
            //no_orden_pago
            if (isset($request['no_orden_pago'])) {
                $whereNoOrdenPago = " AND tab0.no_orden_pago = '" . $request['no_orden_pago'] . "'";
            } else {
                $whereNoOrdenPago = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /**
             * Consulta Estado de la Cuenta - 20160808
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.* 
from(

    select tab3.cod_titulo as cod_titulo, tab1.NO_PROCESO,tab1.ID_ANHOS,tab7.RAZON_SOC AS ABOGADO,
    tab4.DESCRIPCION AS ETAPA,tab0.NUMERO,tab0.FECHA,tab8.DESCRIPCION AS TIPO_DOCUMENTO,tab0.id_actuacion_proc
    
    from CBR_REGISTRO_ETAPA tab0
    
    left join CBR_PROCESO_COACTIVO tab1 ON tab1.ID_PROCESO_COACTIVO = tab0.ID_PROCESO_COACTIVO
    left join CBR_REMISION_TITULO tab2 ON tab2.ID_REMISION_TITULO = tab1.ID_REMISION_TITULO
    left join CBR_TITULO_MINERO_V tab3 ON tab3.cod_titulo = tab2.cod_titulo
    left join CBR_ACTUACION_PROC tab4 ON tab4.ID_ACTUACION_PROC = tab0.ID_ACTUACION_PROC
    left join cbr_reparto tab5 ON tab5.id_remision_titulo = tab1.id_remision_titulo
    left join CBR_ABOGADO tab6  ON tab6.id_abogado = tab5.id_abogado
    left join interceros_v tab7 ON tab7.id_mae_ter = tab6.id_mae_ter
    left join CBR_TIPO_DOCUMENTO tab8 ON tab8.ID_TIPO_DOCUMENTO = tab4.ID_TIPO_DOCUMENTO
                    
)tab0

where 
1 = 1
$whereTituloMinero
$whereNumeroProceso
$whereEtapaProc 
   
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select 
tab0.* 
from(

    select tab3.cod_titulo as cod_titulo, tab1.NO_PROCESO,tab1.ID_ANHOS,tab7.RAZON_SOC AS ABOGADO,
    tab4.DESCRIPCION AS ETAPA,tab0.NUMERO,tab0.FECHA,tab8.DESCRIPCION AS TIPO_DOCUMENTO,tab0.id_actuacion_proc
    
    from CBR_REGISTRO_ETAPA tab0
    
    left join CBR_PROCESO_COACTIVO tab1 ON tab1.ID_PROCESO_COACTIVO = tab0.ID_PROCESO_COACTIVO
    left join CBR_REMISION_TITULO tab2 ON tab2.ID_REMISION_TITULO = tab1.ID_REMISION_TITULO
    left join CBR_TITULO_MINERO_V tab3 ON tab3.cod_titulo = tab2.cod_titulo
    left join CBR_ACTUACION_PROC tab4 ON tab4.ID_ACTUACION_PROC = tab0.ID_ACTUACION_PROC
    left join cbr_reparto tab5 ON tab5.id_remision_titulo = tab1.id_remision_titulo
    left join CBR_ABOGADO tab6  ON tab6.id_abogado = tab5.id_abogado
    left join interceros_v tab7 ON tab7.id_mae_ter = tab6.id_mae_ter
    left join CBR_TIPO_DOCUMENTO tab8 ON tab8.ID_TIPO_DOCUMENTO = tab4.ID_TIPO_DOCUMENTO
                    
)tab0

where 
1 = 1
$whereTituloMinero
$whereNumeroProceso
$whereEtapaProc 
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[ci_cons_est_cuenta] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.no_obligacion, tab0.sec ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $id_anhos = $request['id_anhos'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //Tercero
            if (isset($request['num_doc'])) {
                $whereTercero = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereTercero = ' ';
            }
            //no_radicado
            if (isset($request['no_radicado'])) {
                $whereNoRadicado = " AND tab0.no_radicado = '" . $request['no_radicado'] . "'";
            } else {
                $whereNoRadicado = ' ';
            }
            //no_obligacion
            if (isset($request['no_obligacion'])) {
                $whereNoObligacion = " AND tab0.no_obligacion = '" . $request['no_obligacion'] . "'";
            } else {
                $whereNoObligacion = ' ';
            }
            //no_rp
            if (isset($request['no_rp'])) {
                $whereNoRp = " AND tab0.no_rp = '" . $request['no_rp'] . "'";
            } else {
                $whereNoRp = ' ';
            }
            //no_orden_pago
            if (isset($request['no_orden_pago'])) {
                $whereNoOrdenPago = " AND tab0.no_orden_pago = '" . $request['no_orden_pago'] . "'";
            } else {
                $whereNoOrdenPago = ' ';
            }

            //obtener el listado de recaudos
            // Filtro de conceptos para pago . and concep.pago_func = 1 - 20140428
            $sql = <<<EOD
SELECT

'TOTALES' as no_radicado,
'Cantidad de Obl. '  as clacta,
count(no_obligacion) as no_obligacion,

SUM(valor_cxp)  as valor_cxp,
SUM(vrbruto)  as vrbruto,
SUM(vr_iva)  as vr_iva,
SUM(vr_imp)  as vr_imp,
SUM(vr_neto)  as vr_neto

FROM (   

select 
tab0.* 
from(

    select tab3.cod_titulo as cod_titulo, tab1.NO_PROCESO,tab1.ID_ANHOS,tab7.RAZON_SOC AS ABOGADO,
    tab4.DESCRIPCION AS ETAPA,tab0.NUMERO,tab0.FECHA,tab8.DESCRIPCION AS TIPO_DOCUMENTO,tab0.id_actuacion_proc
    
    from CBR_REGISTRO_ETAPA tab0
    
    left join CBR_PROCESO_COACTIVO tab1 ON tab1.ID_PROCESO_COACTIVO = tab0.ID_PROCESO_COACTIVO
    left join CBR_REMISION_TITULO tab2 ON tab2.ID_REMISION_TITULO = tab1.ID_REMISION_TITULO
    left join CBR_TITULO_MINERO_V tab3 ON tab3.cod_titulo = tab2.cod_titulo
    left join CBR_ACTUACION_PROC tab4 ON tab4.ID_ACTUACION_PROC = tab0.ID_ACTUACION_PROC
    left join cbr_reparto tab5 ON tab5.id_remision_titulo = tab1.id_remision_titulo
    left join CBR_ABOGADO tab6  ON tab6.id_abogado = tab5.id_abogado
    left join interceros_v tab7 ON tab7.id_mae_ter = tab6.id_mae_ter
    left join CBR_TIPO_DOCUMENTO tab8 ON tab8.ID_TIPO_DOCUMENTO = tab4.ID_TIPO_DOCUMENTO
                    
)tab0

where 
1 = 1
$whereTituloMinero
$whereNumeroProceso
$whereEtapaProc 

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
